GEN = {}
GEN.gVersion = '4.03'

-- mission specific functions 
-- load order :
-- 1 MissionGeneratorTools
-- 2 Templates
-- 3 this script

--#################################################################################################################################################
-- #############   Configuration (mission specific)																					############### 
--#################################################################################################################################################
do -- Variables
  GEN.RED = coalition.side.RED	  
  GEN.BLUE = coalition.side.BLUE	
  GEN.Era							= 2 	-- 2 = Modern , 1 = Cold war

end
do -- Templates
--		            groupName,	displayName,	    category,	   side,               era,     disperse,   size,   properties (table, free format)	

--red
	MGT.addTemplate( 'B-M60'   , 'M60'	, 	   'ground',   coalition.side.BLUE, 	  0,          60,		  10,	  {})
  MGT.addTemplate( 'B-M1A2'  , 'M1A2', 	     'ground',   coalition.side.BLUE, 	  0,          60,		  10,	  {})
  MGT.addTemplate( 'B-M113'  , 'M113'	, 	   'ground',   coalition.side.BLUE, 	  0,          60,		  10,	  {})
  MGT.addTemplate( 'B-M2A2'  , 'M12A2', 	   'ground',   coalition.side.BLUE, 	  0,          60,		  10,	  {})
  MGT.addTemplate( 'B-M1126'  , 'M12A2', 	   'ground',   coalition.side.BLUE, 	  0,          60,		  10,	  {})
  MGT.addTemplate( 'B-Humvee', 'Humvee'	,    'ground',   coalition.side.BLUE, 	  0,          60,		  10,	  {})
  MGT.addTemplate( 'B-Avenger', 'Avenger'	,  'sam',      coalition.side.BLUE, 	  0,          60,		  10,	  {})
  MGT.addTemplate( 'B-Vulcan' , 'Vulcan'	,  'aaa',      coalition.side.BLUE, 	  0,          60,		  10,	  {})
  MGT.addTemplate( 'BH-Gaz-L'  , 'Gazelle'	,  'heli',      coalition.side.BLUE, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'BH-Gaz-M'  , 'Gazelle'	,  'heli',      coalition.side.BLUE, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'BH-Gaz-A'  , 'Gazelle'	,  'heli',      coalition.side.BLUE, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'BH-Apache'   , 'Apache'	  ,  'heli',      coalition.side.BLUE, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'BH-AH1'   , 'Super Cobra'	  ,  'heli',      coalition.side.BLUE, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'BH-Kiowa'   , 'Kiowa'	  ,  'heli',      coalition.side.BLUE, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'B-pilot'  , 'Pilot'	  ,  'pilot',      coalition.side.BLUE, 	  0,          30,		  5,	  {})   
  MGT.addTemplate( 'BH-Predator'   , 'Predator'	  ,  'predator',      coalition.side.BLUE, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'B-Roland' , 'Roland ADS'	,  'shorad',      coalition.side.BLUE, 	  0,          30,		  10,	  {})
  
  MGT.addTemplate( 'B-Harrier-CAS' , 'Harrier CAS'	,  'ac',      coalition.side.BLUE, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'B-Harrier-SEAD' , 'Harrier SEAD'	,  'ac',      coalition.side.BLUE, 	  0,          30,		  10,	  {})
  
  MGT.addTemplate( 'B-farp-sup-1' , 'FARP'	,  'farp',      coalition.side.BLUE, 	  0,          0,		  1,	  {})
  MGT.addTemplate( 'B-HQ' , 'HQ'	,  'hq',      coalition.side.BLUE, 	  0,          0,		  10,	  {})
  MGT.addTemplate( 'B-M109-1' ,   'M109 Btty.'	,  'art',      coalition.side.BLUE, 	  0,          0,		  25,	  {})    
  MGT.addTemplate( 'B-MRLS' ,     'MRLS Btty.'	,  'mrls',      coalition.side.BLUE, 	  0,          0,		  1,	  {}) 


	MGT.addTemplate( 'R-T55'   , 'T-55'	, 	   'ground',   coalition.side.RED, 	  0,          60,		  10,	  {})
  MGT.addTemplate( 'R-T72'   , 'T-72'	, 	   'ground',   coalition.side.RED, 	  0,          60,		  10,	  {})  
  MGT.addTemplate( 'R-MTLB'  , 'MTLB'	, 	   'ground',   coalition.side.RED, 	  0,          60,		  10,	  {})
  MGT.addTemplate( 'R-BTR-80', 'BTR-80', 	   'ground',   coalition.side.RED, 	  0,          60,		  10,	  {})  
  MGT.addTemplate( 'R-BMP-1', 'BMP-1', 	   'ground',   coalition.side.RED, 	  0,          60,		  10,	  {})    
  MGT.addTemplate( 'R-BMP-2', 'BMP-2', 	   'ground',   coalition.side.RED, 	  0,          60,		  10,	  {})    
  MGT.addTemplate( 'R-Cobra', 'Cobra'	,    'ground',   coalition.side.RED, 	  0,          60,		  10,	  {})
  MGT.addTemplate( 'R-SA9'   , 'SA-9'	,  'sam',      coalition.side.RED, 	  0,          60,		  10,	  {})
  
  MGT.addTemplate( 'R-Shilka' , 'Shilka'	,  'aaa',      coalition.side.RED, 	  0,          60,		  10,	  {})
  MGT.addTemplate( 'R-ZSU-57-2' , 'ZSU-57-2'	,  'aaa',      coalition.side.RED, 	  0,          60,		  10,	  {})
  MGT.addTemplate( 'R-ZSU-57-2' , 'ZU-23-2'	,  'aaa',      coalition.side.RED, 	  0,          60,		  10,	  {}) 
  
  MGT.addTemplate( 'R-Mi8'  , 'Mi-8'	,  'heli',      coalition.side.RED, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'R-Mi8-1'  , 'Mi-8'	,  'heli',      coalition.side.RED, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'R-Mi24'  , 'Mi-24'	,  'heli',      coalition.side.RED, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'R-Ka50'  , 'Ka-50'	,  'heli',      coalition.side.RED, 	  0,          30,		  10,	  {})
  
  MGT.addTemplate( 'R-MRL',   'MRLS Battery', 	  'support',   coalition.side.RED, 	  0,          60,		  10,	  {})  
  MGT.addTemplate( 'R-ART',   'Artillery Battery', 	  'support',   coalition.side.RED, 	  0,          60,		  10,	  {})  
  MGT.addTemplate( 'R-Sup',   'Supply Plt.', 	  'support',   coalition.side.RED, 	  0,          60,		  10,	  {})    
  MGT.addTemplate( 'R-HQ',   'HQ Plt.', 	  'hq',   coalition.side.RED, 	  0,          60,		  10,	  {})  
  MGT.addTemplate( 'R-SA-8',   'SA-8.', 	  'shorad',   coalition.side.RED, 	  0,          60,		  10,	  {})  
  MGT.addTemplate( 'R-Convoy-1',   'Supply Plt.', 	  'convoy',   coalition.side.RED, 	  0,          0,		  10,	  {})    
  MGT.addTemplate( 'R-Convoy-2',   'Supply Plt.', 	  'convoy',   coalition.side.RED, 	  0,          0,		  10,	  {})    
  MGT.addTemplate( 'R-Convoy-3',   'Supply Plt.', 	  'convoy',   coalition.side.RED, 	  0,          0,		  10,	  {})    
  MGT.addTemplate( 'R-Convoy-4',   'Supply Plt.', 	  'convoy',   coalition.side.RED, 	  0,          0,		  10,	  {})    
  MGT.addTemplate( 'R-INF-2', 'Infantry'	,    'inf',   coalition.side.RED, 	  0,          10,		  0,	  {})
  MGT.addTemplate( 'R-INF-3', 'Infantry'	,    'inf',   coalition.side.RED, 	  0,          10,		  0,	  {})
  MGT.addTemplate( 'R-INF-4', 'Infantry'	,    'inf',   coalition.side.RED, 	  0,          10,		  0,	  {})
  MGT.addTemplate( 'R-INF-5', 'Infantry'	,    'inf',   coalition.side.RED, 	  0,          10,		  0,	  {})
  MGT.addTemplate( 'R-INF-6', 'Infantry'	,    'inf',   coalition.side.RED, 	  0,          10,		  0,	  {})
  MGT.addTemplate( 'R-Patrol-1',   'Patrol', 	  'patrol',   coalition.side.RED, 	  0,          0,		  10,	  {})    
  MGT.addTemplate( 'R-Patrol-2',   'Patrol', 	  'patrol',   coalition.side.RED, 	  0,          0,		  10,	  {})    
  MGT.addTemplate( 'R-Patrol-3',   'Patrol', 	  'patrol',   coalition.side.RED, 	  0,          0,		  10,	  {})    
  MGT.addTemplate( 'R-Patrol-4',   'Patrol', 	  'patrol',   coalition.side.RED, 	  0,          0,		  10,	  {})    
  MGT.addTemplate( 'R-farp-sup-4' , 'FARP'	,  'farp',      coalition.side.RED, 	  0,          0,		  1,	  {})
  MGT.addTemplate( 'R-Bunker-1' , 'Bunker'	,  'bunker',      coalition.side.RED, 	  0,          0,		  1,	  {})
  MGT.addTemplate( 'R-Bunker-2' , 'Bunker'	,  'bunker',      coalition.side.RED, 	  0,          0,		  1,	  {})  
   
end-- Templates

do -- deployment settings										

  GEN.DEF_RED_Ground = 		 {     	
                {name = 'Front',  border = 'border', class = 'ground'	, zoneQty = 15, deployZoneQty = 15, zonePrefix = 'red', 	minPerZone = 0 , maxPerZone = 2 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'CAS',
                components = {}
              }} -- DEF_RED_Ground
  GEN.DEF_RED_Bunker= 		 {     	
                {name = 'FrontBunker',  border = 'border', class = 'bunker'	, zoneQty = 15, deployZoneQty = 7, zonePrefix = 'red', 	minPerZone = 0 , maxPerZone = 2 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND'}, mission = true, missionRadius = 500, missionName = 'CAS',
                components = {}
              }} -- DEF_RED_Ground            

  GEN.DEF_RED_sam = 		 {     	
                {name = 'FrontSAM',  border = 'border', class = 'sam'	, zoneQty = 11, deployZoneQty = 1, zonePrefix = 'red', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'SEAD',
								components = {}														
                }} -- DEF_RED_sam              
   GEN.DEF_RED_aaa = 		 {     	
                {name = 'FrontAAA',  border = 'border', class = 'aaa'	, zoneQty = 11, deployZoneQty = 3, zonePrefix = 'red', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'SEAD',
								components = {}														
              }} -- DEF_RED_aaa         
            
  GEN.DEF_RED_Sup= 		 {     	
                {name = 'Support',  border = 'border', class = 'support'	, zoneQty = 6, deployZoneQty = 6, zonePrefix = 'red-sup', 	minPerZone = 0 , maxPerZone = 3 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'BAI',
                components = {
                    {class = 'aaa'		,	minPerSite = 1 , maxPerSite = 1, minDist =  50, maxDist =  100, probPerSite = 25, side = coalition.side.RED},                  
                  }
              }} -- DEF_RED_Ground
            
  GEN.DEF_RED_HQ= 		 {     	
                {name = 'redHQ',  border = 'border', class = 'hq'	, zoneQty = 2, deployZoneQty = 1, zonePrefix = 'search', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'BAI-C2/HQ',
                components = {
                    {class = 'aaa'		,	minPerSite = 1 , maxPerSite = 1, minDist =  50, maxDist =  100, probPerSite = 25, side = coalition.side.RED},
                    {class = 'sam'		,	minPerSite = 1 , maxPerSite = 1, minDist =  50, maxDist =  100, probPerSite = 10, side = coalition.side.RED},                    
                  }
              }} -- DEF_RED_Ground       
  GEN.DEF_RED_Shorad= 		 {     	
                {name = 'Shorad',  border = 'border', class = 'shorad'	, zoneQty = 2, deployZoneQty = 2, zonePrefix = 'search', 	minPerZone = 0 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'SEAD',
                components = {
               
                  }
              }} -- DEF_RED_Ground                
    
    GEN.DEF_RED_Convoy= 		 {     	
                {name = 'convoy',  border = 'border', class = 'convoy'	, zoneQty = 4, deployZoneQty = 4, zonePrefix = 'red-start', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'BAI - Convoy Interdiction',
                components = {
                   
                  }
              }} -- DEF_RED_Ground
    GEN.DEF_RED_Patrol= 		 {     	
                {name = 'patrol',  border = 'border', class = 'patrol'	, zoneQty = 21, deployZoneQty = 6, zonePrefix = 'patrol', 	minPerZone = 1 , maxPerZone = 1,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 500, missionName = 'BAI - Patrol Interdiction',
                components = {
                   
                  }
              }} -- DEF_RED_Ground            
    
     GEN.DEF_RED_Inf= 		 {     	
                {name = 'redGround',  border = 'border', class = 'inf'	, zoneQty = 120, deployZoneQty = 34, zonePrefix = 'red-ifn', 	minPerZone = 0 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 500, missionName = '',
                components = {
               
                  }
              }} -- DEF_RED_Ground    
            
      GEN.DEF_RED_FARP= 		 {     	
                {name = 'farp',  border = 'border', class = 'farp'	, zoneQty = 1, deployZoneQty = 1, zonePrefix = 'red-farp', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 0, missionName = '',
                components = {
                    {class = 'aaa'		,	minPerSite = 1 , maxPerSite = 2, minDist =  150, maxDist =  200, probPerSite = 50, side = coalition.side.RED},
                    {class = 'sam'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  300, probPerSite = 15, side = coalition.side.RED},                    
                  }
              }}              
                           
              
  GEN.DEF_BLUE_Ground = 		 {     	
                {name = 'blueGround',  border = 'border', class = 'ground'	, zoneQty = 18, deployZoneQty = 18, zonePrefix = 'blue', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.BLUE, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 500, missionName = '',
								components = {}					
                }} -- DEF_BLUE_Ground
              
  GEN.DEF_BLUE_sam = 		 {     	
                {name = 'blueSam',  border = 'border', class = 'sam'	, zoneQty = 18, deployZoneQty = 2, zonePrefix = 'blue', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.BLUE, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 500, missionName = '',
								components = {}					
                }} -- DEF_BLUE_sam              
   GEN.DEF_BLUE_aaa = 		 {     	
                {name = 'blueAAA',  border = 'border', class = 'aaa'	, zoneQty = 18, deployZoneQty = 4, zonePrefix = 'blue', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.BLUE, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 500, missionName = '',
								components = {}
                }} -- DEF_BLUE_aaa              
     GEN.DEF_BLUE_Shorad= 		 {     	
                {name = 'blueShorad',  border = 'border', class = 'shorad'	, zoneQty = 1, deployZoneQty = 1, zonePrefix = 'blue-shorad', 	minPerZone = 0 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.BLUE, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 500, missionName = '',
                components = {
               
                  }
              }} -- DEF_RED_Ground       
            
  GEN.Blue_FARP= 		 {     	
                {name = 'farp',  border = 'border', class = 'farp'	, zoneQty = 1, deployZoneQty = 1, zonePrefix = 'blue-farp', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.BLUE, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 0, missionName = '',
                components = {
                    {class = 'aaa'		,	minPerSite = 1 , maxPerSite = 2, minDist =  150, maxDist =  200, probPerSite = 50, side = coalition.side.BLUE},
                    {class = 'sam'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  300, probPerSite = 15, side = coalition.side.BLUE},                    
                  }
              }}      
  GEN.Blue_ART = 		 {     	
                {name = 'art',  border = 'border', class = 'art'	, zoneQty = 2, deployZoneQty = 2, zonePrefix = 'blue-art', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.BLUE, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 0, missionName = '',
                components = {
                    {class = 'aaa'		,	minPerSite = 1 , maxPerSite = 2, minDist =  150, maxDist =  200, probPerSite = 50, side = coalition.side.BLUE},
                    {class = 'sam'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  300, probPerSite = 15, side = coalition.side.BLUE},                    
                  }
              }}     
  GEN.Blue_MRLS = 		 {     	
                {name = 'MRLS',  border = 'border', class = 'mrls'	, zoneQty = 1, deployZoneQty = 1, zonePrefix = 'blue-mrls', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.BLUE, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 0, missionName = '',
                components = {
                    {class = 'aaa'		,	minPerSite = 1 , maxPerSite = 1, minDist =  150, maxDist =  200, probPerSite = 50, side = coalition.side.BLUE},
                    {class = 'sam'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  300, probPerSite = 10, side = coalition.side.BLUE},                    
                  }
              }}             
 
   GEN.Blue_HQ= 		 {     	
                {name = 'blueHQ',  border = 'border', class = 'hq'	, zoneQty = 1, deployZoneQty = 1, zonePrefix = 'blue-shorad', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.BLUE, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 0, missionName = '',
                components = {
                    {class = 'aaa'		,	minPerSite = 1, maxPerSite = 1, minDist =  150, maxDist =  200, probPerSite = 50, side = coalition.side.BLUE},
                    {class = 'sam'		,	minPerSite = 1 , maxPerSite = 1, minDist =  250, maxDist =  300, probPerSite = 15, side = coalition.side.BLUE},                    
                  }
              }}    
 
           
end -- deployment settings



--#################################################################################################################################################
-- #############   Initialization of globals (mission specific)																		                                  ############### 
--#################################################################################################################################################
do
  GEN.blueGROUPS = {}
  GEN.redGROUPS = {}
  GEN.clientConfig = {}
  GEN.movingGroups = {}
  GEN.movingGroups[coalition.side.RED] = {}
  GEN.movingGroups[coalition.side.BLUE] = {}

  GEN.playerUnits = {}
  GEN.playerGroups = {}
  GEN.PlayerKillTable ={}
  GEN.playerGroupsByID = {}
  GEN.ROEchangeRadiusOnMark = 1000
  GEN.ROEchangeRadiusOnShot = 1000
  GEN.maxWPmarkDist = 50
  GEN.minWPmarkDist = 20
  GEN.rootMenus = {}

  GEN.rootMenus = {}
  GEN.ROEexclusions = {}
  
  GEN.patrolZonesCounter = 0
  GEN.patrolZones = {}
  GEN.PatrolZone = ZONE_POLYGON:New( "border", GROUP:FindByName( "border" ) )  
  GEN.landPatrolZones = {}
  GEN.landPatrolZone = ZONE_POLYGON:New( "landPatrolZone", GROUP:FindByName( "landPatrolZone" ) ) 
  
  GEN.RedBase = ''
  GEN.acType = ''
  GEN.acType1 = ''  
  GEN.RedEWR = ''
  
  GEN.taskXgroupID = {}
  GEN.taskXgroupID_Dest = {}
  GEN.taskCatalog = {}

  GEN.blueCC = nil
  GEN.blue_DetectionSetGroup  = nil
  GEN.blueRecceDetection = nil
  GEN.redCC = nil
  GEN.red_DetectionSetGroup  = nil
  GEN.redRecceDetection = nil
  GEN.markList = {}
  GEN.markedUnits = {}
  GEN.EscortCount = 0
  GEN.EscortSetGroup = {}
  GEN.EscortDetection = {}

end
--#################################################################################################################################################
-- #############   Event Handlers											 	                                                   													############### 
--#################################################################################################################################################
GEN.EventHandler = {}
function GEN.EventHandler:onEvent(_eventDCS)

	if _eventDCS == nil or _eventDCS.initiator == nil then
		return true
	end

	local status, err = pcall(function(_event)

			if _event.id == world.event.S_EVENT_BIRTH  and _event.initiator:getPlayerName()   then  


				GEN.initUnit(_event.initiator:getName())
			
      elseif ( _event.id == world.event.S_EVENT_SHOOTING_START ) or (_event.id == world.event.S_EVENT_SHOT) then 
				
				timer.scheduleFunction(GEN.ShootingEvent, {_event},  timer.getTime() + mist.random(20,50) ) 	
        
			elseif (_event.id == world.event.S_EVENT_EJECTION or _event.id == world.event.S_EVENT_PILOT_DEAD ) and _event.initiator:getPlayerName() then 	
				
				GEN.showScore(_event.initiator:getName())		
			elseif (_event.id == world.event.S_EVENT_KILL)  then 
				GEN.KillEvent(_event)
				
			end --if (_event.id ==
								
		  -- ### End event processing

			return true
	end, _eventDCS) --  local status, err = pcall(function(_event)

	if (not status) then 
		local msg = string.format(">>>>>>>>>>> (v%s): Error while handling event %s",GEN.gVersion, err)
		env.error(msg,false)
	end
end
--===================================================================================================================================================
function GEN.DeadEvent(_event)
	env.info('GEN.DeadEvent() running',false)
	local Name = _event.initiator:getName()
	local Type = _event.initiator:getTypeName()
	local _status,coaliton = pcall(function()
							return {_event.initiator:getCoalition()}
							end)	
	if not _status then
		coalition = 0	
	end 
	

	
	if coalition ~= 0 then
		if Type then
			trigger.action.outText(string.format('%s (%s) destroyed',Name,Type), 10)
		else
			trigger.action.outText(string.format('%s destroyed',Name), 10)
		end
	end
	
end -- function
--===================================================================================================================================================
function GEN.KillEvent(_event)
	env.info('GEN.KillEvent() running',false)
	
	
	if _event.initiator ~= nil and _event.target ~= nil  then
		local p =  _event.initiator:getPlayerName() 
		
		if not p then
			if _event.initiator:getCoalition() == 1 then
				p = 'Red AI'
			else
				p = 'Blue AI'
			end
		end
		
		
		
		if not GEN.PlayerKillTable[p] then
			GEN.PlayerKillTable[p] = {}
		end
		
		local t = _event.target:getTypeName()
		if t then
      local weapon = (_event.target:getCategory() == 2)
      if not weapon then
        if not GEN.PlayerKillTable[p][t] then
          GEN.PlayerKillTable[p][t] = {}
        end
        local c = 'Neutral'    
        if _event.target:getCoalition() <= 1   then
          c = 'Red'
        elseif _event.target:getCoalition() == 2 then
          c = 'Blue'
        end
        
        if not GEN.PlayerKillTable[p][t][c] then
          GEN.PlayerKillTable[p][t][c] = 1
        else
          GEN.PlayerKillTable[p][t][c] = GEN.PlayerKillTable[p][t][c]  + 1
        end
        env.info('GEN.KillEvent() p<'..p..'> t<'..t..'> c<'..c..'>',false)
      end
    end
	end
	
end -- function
--===================================================================================================================================================
function GEN.ShootingEvent(params,time)

	env.info('GEN.ShootingEvent() running',false)
	local _event = params[1]
	local _status,shooterName  pcall(function() return _event.initiator:getName() end)
	
	if _status then
		local UnitZoneTable = GEN.getUnitZoneTable('ALL')	
		
		local t = mist.getUnitsInMovingZones(UnitZoneTable, {shooterName}, GEN.ROEchangeRadiusOnShot, 'cylinder')
		
		
		for i = 1,d35.rowCount(t) do
			d35.setGroupOption(t[i]:getGroup():getName(),0,2) -- open fire
		end --for i = 1,d35.rowCount(t) do
	end	
	return nil
end --function
--===================================================================================================================================================
function GEN.initUnit(unitName)
	local unit = Unit.getByName(unitName)
	local groupID = unit:getGroup():getID()
	local groupName = unit:getGroup():getName()
	local unitType =  unit:getTypeName()
	local side = unit:getCoalition()
	local clientConfig = {
								groupID = groupID
							,	unitType = unitType
							,	side = side
							,	AltitudeUOM = 1
						}
		
	if not GEN.clientConfig[unitName] then -- new player
		dummy = 0
		
	else -- returning player
		dummy = 0
	end

	if not d35.inTable(unitName,GEN.playerUnits) then
		table.insert(GEN.playerUnits,unitName)
		if not d35.inTable(groupID,GEN.playerGroups) then
			table.insert(GEN.playerGroups,groupID)
      local isHelo = (unit:getDesc().category == 1)
			GEN.rootMenus[groupID] ={}
			GEN.playerGroupsByID[groupID] = groupName
			GEN.rootMenus[groupID]['Intelligence'] =  missionCommands.addSubMenuForGroup(groupID,'Intelligence',nil)
			missionCommands.addCommandForGroup(groupID,"Intelligence Summary", GEN.rootMenus[groupID]['Intelligence'] , GEN.showScore, groupName) 
			missionCommands.addCommandForGroup(groupID,"Kills Summary", GEN.rootMenus[groupID]['Intelligence'] ,GEN.showKills, groupName )
      GEN.rootMenus[groupID]['Escort'] =  missionCommands.addSubMenuForGroup(groupID,'Request Escort',GEN.rootMenus[groupID]['Intelligence'] )
      if isHelo then
        missionCommands.addCommandForGroup(groupID,"Apache", GEN.rootMenus[groupID]['Escort'] ,GEN.deployEscortHelo,{unitName,'BH-Apache','Apache'})
        missionCommands.addCommandForGroup(groupID,"Gazelle", GEN.rootMenus[groupID]['Escort'] ,GEN.deployEscortHelo,{unitName,'BH-Gaz-L','Gazelle'})
        missionCommands.addCommandForGroup(groupID,"Gazelle/AT", GEN.rootMenus[groupID]['Escort'] ,GEN.deployEscortHelo,{unitName,'BH-Gaz-M','Gazelle/AT'})
        missionCommands.addCommandForGroup(groupID,"Gazelle/AA", GEN.rootMenus[groupID]['Escort'] ,GEN.deployEscortHelo,{unitName,'BH-Gaz-A','Gazelle/AA'})
        missionCommands.addCommandForGroup(groupID,"SuperCobra", GEN.rootMenus[groupID]['Escort'] ,GEN.deployEscortHelo,{unitName,'BH-AH1','SuperCobra'})   
        missionCommands.addCommandForGroup(groupID,"Kiowa", GEN.rootMenus[groupID]['Escort'] ,GEN.deployEscortHelo,{unitName,'BH-Kiowa','Kiowa'}) 
      else
        missionCommands.addCommandForGroup(groupID,"Harrier (CAS)", GEN.rootMenus[groupID]['Escort'] ,GEN.deployEscortFIX,{unitName,'B-Harrier-CAS','CAS-Harrier'})
        missionCommands.addCommandForGroup(groupID,"Harrier (SEAD)", GEN.rootMenus[groupID]['Escort'] ,GEN.deployEscortFIX,{unitName,'B-Harrier-SEAD','SEAD-Harrier'})       
      end
      missionCommands.addCommandForGroup(groupID,"Request Tasking", GEN.rootMenus[groupID]['Intelligence'] ,GEN.requestTasking, {groupID,groupName} )
      missionCommands.addCommandForGroup(groupID,"Deploy Predator", GEN.rootMenus[groupID]['Intelligence'] ,GEN.deployPredator, {} )
      GEN.taskXgroupID[groupID] = nil
		end
	end
  GEN.clientConfig[unitName] = clientConfig
	return true
end
--#################################################################################################################################################
-- #############   mission generation code						                                          			 	  													############### 
--#################################################################################################################################################
function GEN.addGroups(_groupData, _side)
	local h,n  = d35.getGroupHealth(_groupData.name)
	local id =  d35.getNextID()
	local row = {
				name 		        = _groupData.name
			,	displayName     = _groupData.template.displayName
			,	position	      = _groupData.pos
			,	health0		      = h
			, isTarget	      = false
			, unitCount0        = n
			, templateGroupName	= _groupData.template.groupName
			, templateCategory	= _groupData.template.category
			,	afacPriority		  = _groupData.template.afacPri
			,	brief				      = _groupData.template.brief
			,	id					      =  id
		}
		
	env.info('GEN.addGroups(): Group: '.._groupData.name..' side: '.._side..' h0/n :'..h..'/'..n,false)
		
	if _side == 1 then
		GEN.redGROUPS[row.name] = row
	elseif _side == 2 then
		GEN.blueGROUPS[row.name] = row
	end
end-- function
--===================================================================================================================================================
function GEN.deployUnits(definition)
  env.error('GEN.deployUnits() in: ',false)
 
	for _,siteType in pairs(definition) do
    env.error('GEN.deployUnits() start: '..siteType.name,false)
    local border = siteType.border
		local zoneList = {}
		local TMPzoneList = mist.randomizeNumTable( {size = siteType.zoneQty,  lowerLimit = 1, upperLimit = siteType.zoneQty})
		for i = 1,siteType.deployZoneQty do
			table.insert(zoneList,TMPzoneList[i])
		end
		for _,z in pairs(zoneList) do
			if mist.random(1,100) <= siteType.probPerZone then
				local qty = mist.random(siteType.minPerZone,siteType.maxPerZone)
				env.error('GEN.deployUnits(): '..siteType.class..' @ '..string.format('%s-%s',siteType.zonePrefix,z)..' #:'..qty,false)
				if qty > 0 then
					local zone = trigger.misc.getZone(string.format('%s-%s',siteType.zonePrefix,z))
					for i = 1,qty do
						local templates, n = MGT.getTemplateList ({siteType.class}, siteType.side, GEN.Era)
						local template = templates[mist.random(1,n)]
            
						local deployedGroups = MGT.populateLand({template}, 1, zone.point, border	, 0, zone.radius, 0,0,0,true,siteType.terrain,4000)
            local my_csar = CSAR:New(coalition.side.BLUE,"Downed Pilot","Luftrettung")
						local nGrp = d35.rowCount(deployedGroups) 
						env.error('GEN.deployUnits(): '..template.groupName,false)
						for j = 1,nGrp do
							local site = deployedGroups[j]
							GEN.addGroups(site,siteType.side)-- group to red list	
							-- do anything aditional at site level
              -- add supression
              if not d35.inTable(siteType.name,{'Naval'}) then
                local G = GROUP:FindByName(site.name)
                local S = SUPPRESSION:New(G)
       
                S:Fallback(false)
                S:Takecover(false)
              end
                      
			
              local C = nil
              if  d35.inTable(siteType.name,{'convoy'}) then
                  local speed = mist.random(10, 20)
                  local G = GROUP:FindByName(site.name)
                  local d = mist.random(1, 6)
                  local dest = "red-sup-"..d
                  C = COORDINATE:NewFromVec2(mist.getRandomPointInZone(dest,0))
                  G:RouteGroundOnRoad(C, speed, 1)
               end
               
              if  d35.inTable(siteType.name,{'patrol'}) then
                  local speed = mist.random(10, 20)
                  local G = GROUP:FindByName(site.name)
                  G:PatrolZones({GEN.landPatrolZone }, speed)
               end
               
                if  d35.inTable(siteType.name,{'blueHQ'}) then
                  local G = GROUP:FindByName(site.name)
                  GEN.blueCC = COMMANDCENTER:New( G, "HQ Blue" )
                  env.info('Blue HQ set as CC',false)
               end
     
                if  d35.inTable(siteType.name,{'redHQ'}) then
                  local G = GROUP:FindByName(site.name)
                  GEN.redCC = COMMANDCENTER:New( G, "HQ Red" )
                  env.info('Red HQ set as CC',false)
               end     
     
              if siteType.mission then
                local name = siteType.missionName
                if name == '' then
                  name = template.displayName
                end 
                local task = {target = site.name, radius = siteType.missionRadius, displayName = name, destination = C, available = false, assigned = 0}
                GEN.taskCatalog[site.name]=task
              end
              
              
              -- Deploy site components 
							env.info('GEN.deployUnits(): components '..d35.rowCount(siteType.components),false)
							if d35.rowCount(siteType.components) > 0 then
								for _,def in pairs(siteType.components) do
									if mist.random(1,100) <= def.probPerSite then
										local dqty = mist.random(def.minPerSite,def.maxPerSite)
										env.info('MGT.deployUnits(): component '..def.class..' @ '..string.format('%s-%s',siteType.zonePrefix,z)..' #:'..dqty,false)
										if dqty > 0 then
											local dtemplates, dn = MGT.getTemplateList ({def.class}, def.side, GEN.Era)
											local dtemplate = dtemplates[mist.random(1,dn)]
											local ddeployedGroups = MGT.populateLand({dtemplate}, dqty, site.pos, border , def.minDist, def.maxDist, 0,0,0,false,{'LAND'},1000)
											local dnGrp = d35.rowCount(ddeployedGroups) 
											env.info('MGT.deployUnits(): component '..dtemplate.groupName,false)
											for dj = 1,dnGrp do
												local grp = ddeployedGroups[dj]
												GEN.addGroups(grp,def.side)-- group to red list		
												-- do anything aditional at component level

                        -- add supression
                        local G = GROUP:FindByName(grp.name)
                        local S = SUPPRESSION:New(G)
                        S:Fallback(false)
                        S:Takecover(false)
												
											end--for dj = 1,dnGrp do
										end--if dqty > 0 then
									end --if mist.random(1,100) <= def.probPerSite then
								end--for _,def in pairs(siteType.component) do
							end -- if MGT.rowCount(siteType.component) > 0 then					
						end	--for j = 1,nGrp do		
					end -- for i = 1,qty do
				end -- if qty > 0 then
			end --if mist.random(1,100) <= siteType.probPerZone then
		end -- for _,z = 1 in pairs(zoneList) do
    env.info('GEN.deployUnits() end: '..siteType.name,false)
	end --for _,siteType in pairs(MGT.UnitsDef) do

	env.info('GEN.deployUnits() out: ',false)

	--trigger.action.outText( 'Units Deployed ', 1 )
end -- function
--===================================================================================================================================================
function GEN.deployRedAir()


  GEN.red_DetectionSetGroup = SET_GROUP:New()
	GEN.red_DetectionSetGroup:FilterPrefixes( {  "R-"} ) -- Depends on IADS EWR network
	GEN.red_DetectionSetGroup:FilterStart()	
  
 
  local Detection = DETECTION_AREAS:New(GEN.red_DetectionSetGroup, 500000 )
  local BAIZone1 = ZONE_POLYGON:New( "casZone", GROUP:FindByName( 'casZone') )
  local CASZone1 = ZONE_POLYGON:New( "casZone", GROUP:FindByName( 'casZone') )
	GEN.RED_A2GDispatcher = AI_A2G_DISPATCHER:New( Detection )
	GEN.RED_A2GDispatcher:SetDefaultOverhead( 1 )
  GEN.RED_A2GDispatcher:SetDefenseRadius( 300000 )
	GEN.RED_A2GDispatcher:SetDefenseReactivityHigh()
  GEN.RED_A2GDispatcher:SetBorderZone( BAIZone1 )


  local templates, n = MGT.getTemplateList ({'heli'}, coalition.side.RED, GEN.Era)
  local prefix ='R-FARP-'
  local types = {}
  for i = 1,n do
    table.insert(types,templates[i].groupName)
  end
  for i = 1,2 do
    local SQDNname = prefix..i
    GEN.RED_A2GDispatcher:SetSquadron(SQDNname, 'R-FARP-1', types , 20)
    GEN.RED_A2GDispatcher:SetSquadronTakeoffFromParkingHot(SQDNname)
    GEN.RED_A2GDispatcher:SetSquadronLandingAtEngineShutdown(SQDNname)
    GEN.RED_A2GDispatcher:SetSquadronGrouping(SQDNname, 1 )
    GEN.RED_A2GDispatcher:SetSquadronFuelThreshold(SQDNname, 0.30 ) 
    if i == 1 then
      GEN.RED_A2GDispatcher:SetSquadronBaiPatrol( SQDNname,BAIZone1,100,500)
      GEN.RED_A2GDispatcher:SetSquadronBaiPatrolInterval(SQDNname, 2, 15, 30)
    else
      GEN.RED_A2GDispatcher:SetSquadronCasPatrol( SQDNname,CASZone1,100,500)
      GEN.RED_A2GDispatcher:SetSquadronCasPatrolInterval(SQDNname, 2, 15, 30)     
    end
  end
  
  
end-- function
--===================================================================================================================================================
function GEN.deployPredator()
  local templates, n = MGT.getTemplateList ({'predator'}, coalition.side.BLUE, GEN.Era)
  local template = templates[mist.random(1,n)]
  local newGRPname = string.format('%s-%s',template.groupName,d35.getNextID())
  local flightSpawn = SPAWN:NewWithAlias( template.groupName,newGRPname)
  local flight = flightSpawn:Spawn()
  
  GEN.patrolZonesCounter = GEN.patrolZonesCounter + 1
  if GEN.patrolZonesCounter > 20 then
     GEN.patrolZonesCounter = 1
  end
  
  GEN.patrolZones[GEN.patrolZonesCounter] = AI_PATROL_ZONE:New( GEN.PatrolZone, mist.random(mist.utils.feetToMeters(15000),mist.utils.feetToMeters(25000))
                                                                        , mist.random(mist.utils.feetToMeters(15000),mist.utils.feetToMeters(25000))
                                                                        , mist.random(mist.utils.knotsToMps(100)*3.6,mist.utils.knotsToMps(150)*3.6)
                                                                        , mist.random(mist.utils.knotsToMps(100)*3.6,mist.utils.knotsToMps(150)*3.6) )
  GEN.patrolZones[GEN.patrolZonesCounter]:SetControllable(flight)
  GEN.patrolZones[GEN.patrolZonesCounter]:Start(1)
  
  
end -- function
--===================================================================================================================================================
function GEN.deployBlueAir()

  GEN.blue_DetectionSetGroup = SET_GROUP:New()
	GEN.blue_DetectionSetGroup:FilterPrefixes( {  "BH-"} ) -- Depends on IADS EWR network
	GEN.blue_DetectionSetGroup:FilterStart()	
  
 
  local Detection = DETECTION_AREAS:New(GEN.blue_DetectionSetGroup, 500000 )
  local BAIZone1 = ZONE_POLYGON:New( "border", GROUP:FindByName( 'border') )
  local CASZone1 = ZONE_POLYGON:New( "casZone", GROUP:FindByName( 'casZone') )
	GEN.BLUE_A2GDispatcher = AI_A2G_DISPATCHER:New( Detection )
	GEN.BLUE_A2GDispatcher:SetDefaultOverhead( 1 )
  GEN.BLUE_A2GDispatcher:SetDefenseRadius( 300000 )
	GEN.BLUE_A2GDispatcher:SetDefenseReactivityHigh()
  GEN.BLUE_A2GDispatcher:SetBorderZone( BAIZone1 )


  local templates, n = MGT.getTemplateList ({'heli'}, coalition.side.BLUE, GEN.Era)
  local prefix ='B-FARP-'
  local types = {}
  for i = 1,n do
    table.insert(types,templates[i].groupName)
  end
  for i = 1,2 do
    local SQDNname = prefix..i
    GEN.BLUE_A2GDispatcher:SetSquadron(SQDNname, 'FARP London - 01', types , 20)
    GEN.BLUE_A2GDispatcher:SetSquadronTakeoffFromParkingHot(SQDNname)
    GEN.BLUE_A2GDispatcher:SetSquadronLandingAtEngineShutdown(SQDNname)
    GEN.BLUE_A2GDispatcher:SetSquadronGrouping(SQDNname, 1 )
    GEN.BLUE_A2GDispatcher:SetSquadronFuelThreshold(SQDNname, 0.30 ) 
    if i == 1 then
      GEN.BLUE_A2GDispatcher:SetSquadronBaiPatrol( SQDNname,BAIZone1,100,500)
      GEN.BLUE_A2GDispatcher:SetSquadronBaiPatrolInterval(SQDNname, 2, 15, 30)
    else
      GEN.BLUE_A2GDispatcher:SetSquadronCasPatrol( SQDNname,CASZone1,100,500)
      GEN.BLUE_A2GDispatcher:SetSquadronCasPatrolInterval(SQDNname, 2, 15, 30)      
    end
  end
  
  --GEN.BLUE_A2GDispatcher:SetTacticalDisplay( true )

end-- function
--===================================================================================================================================================
function GEN.deploySAR(params, time)
 local zone = 'search-'..mist.random(1,2)
 BlueCsar:SpawnCSARAtZone( zone, coalition.side.BLUE,"Pilot One", true )
 env.info('>>> GEN.deploySAR() ',false)
 return timer.getTime() + 600 + mist.random(0,300)
end -- function
--===================================================================================================================================================
function GEN.deploy()
  env.info('GEN.deploy() starts',false)

  BlueCsar = CSAR:New(coalition.side.BLUE,"B-pilot","Luftrettung") 
  BlueCsar.radioSound = "beacon.ogg" 
  BlueCsar.immortalcrew = false 
  BlueCsar.invisiblecrew = false
  BlueCsar.csarPrefix = { "Gazelle", "Huey"}
  BlueCsar.coordtype = 3
  BlueCsar.csarOncrash = true 
  BlueCsar.enableForAI = true
  BlueCsar.extractDistance = 100
  BlueCsar.loadDistance = 10 
  BlueCsar:__Start(5)

  GEN.deployRedAir()
  GEN.deployBlueAir()


  GEN.deployUnits(GEN.DEF_RED_Ground)
  GEN.deployUnits(GEN.DEF_RED_Bunker)
  GEN.deployUnits(GEN.DEF_RED_sam)
  GEN.deployUnits(GEN.DEF_RED_aaa)  
  GEN.deployUnits(GEN.DEF_RED_Sup)
  GEN.deployUnits(GEN.DEF_RED_Shorad)
  GEN.deployUnits(GEN.DEF_RED_HQ)
  GEN.deployUnits(GEN.DEF_RED_Convoy)
  GEN.deployUnits(GEN.DEF_RED_Patrol)
  GEN.deployUnits(GEN.DEF_RED_Inf)
  GEN.deployUnits(GEN.DEF_RED_FARP)
  
  GEN.deployUnits(GEN.DEF_BLUE_Ground)  
  GEN.deployUnits(GEN.DEF_BLUE_sam)
  GEN.deployUnits(GEN.DEF_BLUE_aaa)    
  GEN.deployUnits(GEN.DEF_BLUE_Shorad)
  GEN.deployUnits(GEN.Blue_FARP)
  GEN.deployUnits(GEN.Blue_ART)
  GEN.deployUnits(GEN.Blue_MRLS)
  GEN.deployUnits(GEN.Blue_HQ)
  
  
  -- start recon
  GEN.blueRecceDetection = DETECTION_UNITS:New( GEN.blue_DetectionSetGroup  )
  GEN.blueRecceDetection:SetRefreshTimeInterval( 30 )
  GEN.blueRecceDetection:SetDistanceProbability(0.5)
  GEN.blueRecceDetection:SetAlphaAngleProbability(0.5)
  
  GEN.blueRecceDetection:Start()
  
 -- GEN.redRecceDetection = DETECTION_UNITS:New( GEN.red_DetectionSetGroup  )
 -- GEN.redRecceDetection:SetRefreshTimeInterval( 30 )
 -- GEN.redRecceDetection:SetDistanceProbability(0.6)
  
--  GEN.redRecceDetection:Start()
  
  
  timer.scheduleFunction( GEN.deploySAR, {},  timer.getTime() + 120 + mist.random(0,300))
  timer.scheduleFunction(GEN.markCleanUp, {},  timer.getTime() + 120 )
  env.info('GEN.deploy() ends',false)
  trigger.action.outText( 'Deployment completed', 1 )
end -- function
--===================================================================================================================================================
function GEN.getUnitZoneTable(_side)
	-- get one alive unit per red group
	local side = _side
	if not side then
		side = 'RED'
	end
	local t = {}
	if side == 'RED' or side == 'ALL' then 
		for _,v in pairs(GEN.redGROUPS) do
			local g = Group.getByName(v.name)
			if g then
				for _,unit in pairs(g:getUnits()) do
					if unit:getLife() >= 1 then
						table.insert(t,unit:getName())
						break
					end
				end --for _,unit in pairs(g) do
			end
		end --for _,v in pairs(GEN.redGROUPS) do
	end--if side =- 'RED' or side =- 'ALL' then 
	if side == 'BLUE' or side == 'ALL' then 
		for _,v in pairs(GEN.blueGROUPS) do
			local g = Group.getByName(v.name)
			if g then
				for _,unit in pairs(g:getUnits()) do
					if unit:getLife() >= 1 then
						table.insert(t,unit:getName())
						break
					end
				end --for _,unit in pairs(g) do
			end
		end --for _,v in pairs(GEN.redGROUPS) do
	end--if side =- 'BLUE' or side =- 'ALL' then 
	return t
end -- function
--===================================================================================================================================================
function GEN.setRedGroupROE(_groupName, prob)
  if not d35.inTable(_groupName, GEN.ROEexclusions ) then
    table.insert(GEN.ROEexclusions,_groupName)
    if mist.random(1,100) <= prob then
      d35.setGroupOption(_groupName, 0,2) -- open fire
      env.info(string.format('GEN.setRedGroupROE() %s set to open fire ',_groupName),false)
    else
      d35.setGroupOption(_groupName, 0,3) -- return fire
      env.info(string.format('GEN.setRedGroupROE() %s set to return fire ',_groupName),false)
    end
  end
end --function
--===================================================================================================================================================
function GEN.showKills(_groupName)
	local rpt = ''
	env.info('GEN.showKills start',false)
	if d35.rowCount(GEN.PlayerKillTable) > 0 then
		for player,killsCoalition in pairs(GEN.PlayerKillTable) do
			rpt = string.format('%s%s :\n',rpt,player)
			for t,kc in pairs(killsCoalition) do
				for c,k in pairs(kc) do
					rpt = string.format('%s   -> %s   <%s>(x%s)\n',rpt,t,c,k)
				end
			end
		end		
	else
		rpt = 'nothing to report'
	end
	
	d35.messageToGroup(_groupName,rpt,30)
	env.info('GEN.showKills end',false)

end -- function
--===================================================================================================================================================
function GEN.showScore(_groupName)
	local TU = 0
	local TG = 0
  local msg = ''
	
	-- agregate RED data
  local rTOO = 0
	local rH0 = 0
	local rH = 0
	local rN0 = 0
	local rN = 0
	for _,grpdata in pairs(GEN.redGROUPS) do
		local h,n =  d35.getGroupHealth(grpdata.name)
		rH0 = rH0 + grpdata.health0
		rH = rH + h
		rN0 = rN0 + grpdata.unitCount0 
		rN = rN + n
		if h <=0 then
      rTOO = rTOO + 1
		end
		TG = TG +1
	end
	TU = TU + rN0

  -- agregate BLUE data
  local bTOO = 0
	local bH0 = 0
	local bH = 0
	local bN0 = 0
	local bN = 0    
	for _,grpdata in pairs(GEN.blueGROUPS) do
		local h,n =  d35.getGroupHealth(grpdata.name)
		bH0 = bH0 + grpdata.health0
		bH = bH + h
		bN0 = bN0 + grpdata.unitCount0 
		bN = bN + n
		if h <=0 then
      bTOO = bTOO + 1
		end
		TG = TG +1
	end
	TU = TU + rN0

  
	
	
	msg = 'Enemy Forces \n'
	msg = string.format('%s   Strength: %s%%\n',msg,mist.utils.round(rH*100/rH0, 2))
	--msg = string.format('%s   Groups destroyed: %s\n',msg,rTOO)
	msg = string.format('%s   Units destroyed: %s\n',msg,(rN0-rN))

  
	
	msg = msg..'\nBlue Forces \n'
	msg = string.format('%s   Strength: %s%%\n',msg,mist.utils.round(bH*100/bH0, 2))
	--msg = string.format('%s   Groups destroyed: %s\n',msg,bTOO)
	msg = string.format('%s   Units destroyed: %s\n',msg,(bN0-bN))
	
  local tasks = d35.rowCount(GEN.getAvailableTasks())
  msg = string.format('\n%s   Available tasks: %s\n',msg,tasks)
	
	msg = string.format('%s\n< %s / %s / %s>\n',msg,TG,TU,d35.rowCount(GEN.markList))
	
	
	d35.messageToGroup(_groupName,msg,20)
end-- function
--===================================================================================================================================================
function GEN.requestTasking(params)
  local groupID = params[1]
  local groupName = params[2]
  
  if GEN.taskXgroupID[groupID] then
    trigger.action.removeMark(GEN.taskXgroupID[groupID])
  end
  if GEN.taskXgroupID_Dest[groupID] then
    trigger.action.removeMark(GEN.taskXgroupID_Dest[groupID])
  end
   -- get new task
   local tasks = GEN.getAvailableTasks()
  if d35.rowCount(tasks) > 0 then
    local cat = {}
    for _,row in pairs(tasks) do
      if d35.isGroupAlive(row.target) then
        table.insert(cat,row)
      end
    end--for _,row in pairs(GEN.taskCatalog) do
    local nt = d35.rowCount(cat)
    if nt > 0 then
      local t = mist.random(1,nt)
      local task = cat[t]
      local taskType = 'Search & Destroy'
      if task.radius == 0 then
        taskType = 'Destroy'
      end
      local pos = d35.getGroupPOS(task.target)
      --local C = COORDINATE:NewFromVec3(pos)
      local briefing = task.displayName
      local markID = d35.getNextID()
      d35.messageToGroup(groupName,briefing)
      local markPos =  mist.utils.makeVec3GL(mist.getRandPointInCircle(pos,task.radius,0,0,360))
      trigger.action.markToGroup(markID , briefing , markPos , groupID , true)
      GEN.taskXgroupID[groupID] = markID
      if task.destination then
        local markID = d35.getNextID()
        local markPos =  mist.utils.makeVec3GL(mist.getRandPointInCircle(task.destination:GetVec3() ,task.radius,0,0,360))
        trigger.action.markToGroup(markID , briefing..' destination' , markPos , groupID , true)
        GEN.taskXgroupID_Dest[groupID] = markID
      end
      
      
    else
      d35.messageToGroup(groupName,'No more task available.')
    end --if nt > 0 then
  end-- if d35.rowCount(GEN.taskCatalog) > 0 then

end -- function
--===================================================================================================================================================
function GEN.markUnit(_unit)
  
  env.info('>>>>> GEN.markUnit() start',false)
  if not GEN.markedUnits[_unit:GetName()] then
    GEN.markedUnits[_unit:GetName()]  = 0
  end
  
  GEN.taskCatalog[_unit:GetGroup():GetName()].available = true
  
  if GEN.markedUnits[_unit:GetName()] == 0 then
    local markColor = ''
    local markShape = ''
    local desc = ''
    if _unit:HasAttribute("MANPADS") or _unit:HasAttribute("MANPADS AUX") then
      markColor = 'yellow'
      markShape = 'circle'
      desc = 'Infantry'
    elseif _unit:HasAttribute("Infantry") then
      markColor = 'yellow'
       markShape = 'circle'
      desc = 'Infantry'
    elseif _unit:HasAttribute("Fortifications") then
      markColor = 'black'
      markShape = 'trapezoid'
      desc = 'Fortification'
    elseif _unit:HasAttribute("AAA") then
      markColor = 'yellow'
      markShape = 'triangle'
       desc = 'AAA'      
    elseif _unit:HasAttribute("SAM")  or _unit:HasAttribute("SAM related") then
      markColor = 'red'
      markShape = 'triangle'
      desc = 'SAM'
    elseif _unit:HasAttribute("Tanks") then
      markColor = 'red'	
      markShape = 'square'
      desc = 'Armor'
    elseif _unit:HasAttribute("IFV") then
      markColor = 'red'
      markShape = 'square'
      desc = 'Armor'
    elseif _unit:HasAttribute("APC") then
      markColor = 'yellow'
      markShape = 'square'
      desc = 'Vehicles'
    elseif _unit:HasAttribute("Trucks") then
      markColor = 'yellow'
      markShape = 'square'
      desc = 'Vehicles'
    elseif _unit:HasAttribute("Helicopters") then
      markColor = 'bright yellow'
      markShape = 'diamond'
    elseif _unit:HasAttribute("Planes") then
      markColor = 'bright red'
      markShape = 'diamond'
    else 
      markColor = 'nomark'
      env.info('GEN.markUnit() nomark',false)
    end

    if markColor ~= 'nomark' then
      local id =  d35.getNextID()
      pos = _unit:GetCoord():GetVec3()
      local to = 3600
      
      if _unit:GetVelocityKMH() > 0 then
        to = 29
      end
      local row = {
                      name = _unit:GetName()
                    , id = id
                    , to =timer.getTime() + to
                  }        
      local color = {}
      if markColor == 'red' then
        color = {1,0,0,0.5}
      elseif markColor == 'yellow' then
         color = {1,1,0,0.5}
      elseif markColor == 'bright red' then
        color = {1,0,0,1}
      elseif markColor == 'bright yellow' then
         color = {1,1,0,1}         
      elseif markColor == 'black' then
        color = {0.25,0.25,0.25,0.5}
      elseif markColor == 'gray' then
        color = {0.5,0.5,0.5,0.5}
      end
      local size = 100
      if markShape ==  'circle' then
      trigger.action.circleToAll(
          coalition.side.BLUE 
        , id 
        , pos 
        , size
        , {0,0,0,1}
        , color
        , 1
        , true
        , ''
      )         
    else
        local p1 =   {}
        local p2 =   {}
        local p3 =   {}
        local p4 =   {}
      if markShape ==  'square' then
        size = 100
        p1 =  mist.vec.add(pos,{x = size, y = 0, z= -size}) 
        p2 =  mist.vec.add(pos,{x = size, y = 0, z= size}) 
        p3 =  mist.vec.add(pos,{x = -size, y = 0, z= size}) 
        p4 =  mist.vec.add(pos,{x = -size, y = 0, z= -size}) 
      elseif markShape ==  'triangle' then
        size = 150
        p1 =  mist.vec.add(pos,{x = size, y = 0, z= 0}) 
        p2 =  mist.vec.add(pos,{x = size, y = 0, z= 0}) 
        p3 =  mist.vec.add(pos,{x = -size * 0.5, y = 0, z= size*0.866}) 
        p4 =  mist.vec.add(pos,{x = -size *0.5, y = 0, z= -size*0.866})    
      elseif markShape ==  'diamond' then
        size = 135
        p1 =  mist.vec.add(pos,{x = size, y = 0, z= 0}) 
        p2 =  mist.vec.add(pos,{x = 0 , y = 0, z= size}) 
        p3 =  mist.vec.add(pos,{x = -size, y = 0, z= 0})  
        p4 =  mist.vec.add(pos,{x = 0 , y = 0, z= -size})        
      elseif markShape ==  'trapezoid' then
        size = 110
        p1 =  mist.vec.add(pos,{x = size*0.8, y = 0, z= -size*0.5}) 
        p2 =  mist.vec.add(pos,{x = size*0.8, y = 0, z= size*0.5}) 
        p3 =  mist.vec.add(pos,{x = -size*0.8, y = 0, z= size}) 
        p4 =  mist.vec.add(pos,{x = -size*0.8, y = 0, z= -size})         
      end
      trigger.action.quadToAll(
            coalition.side.BLUE 
          , id
          , p1 
          , p2
          , p3
          , p4
          ,  {0, 0, 0, 1}
          , color
          , 1
          , true
          , ''
        )
      
    end
    
      GEN.markList[id] = row   
      GEN.markedUnits[_unit:GetName()] = id
      local msg = string.format('=============> GEN.markUnit(%s) shape: %s color: %s id: %s to:%s',_unit:GetName(),markShape,markColor,id,to)
      env.info(msg,false)
    end
  end
end -- function
--===================================================================================================================================================
function GEN.markCleanUp(params,time)
  if d35.rowCount(GEN.markList) > 0 then
    local t = timer.getTime()
    for id,row in pairs(GEN.markList) do
      local remove = false
      if t >= row.to then
        remove = true
        env.info('GEN.markCleanUp() id: '..id..' timeout',false)
      else
        local U = UNIT:FindByName(row.name)
        if U then
          if not U:IsAlive() then
            remove = true
            env.info('GEN.markCleanUp() id: '..id..' unit dead',false)
          end
        else
          remove = true
          env.info('GEN.markCleanUp() id: '..id..' unit does not exist',false)
        end
      end
      if remove then
        trigger.action.removeMark(id)
        GEN.markList[row.id] = nil
        GEN.markedUnits[row.name]  = 0
        env.info('GEN.markCleanUp() id: '..id..' removed',false)
      end
    end
  end
  return timer.getTime()+15
end -- function

--===================================================================================================================================================
function GEN.getAvailableTasks()
  local ret = {}
  for _, task in pairs (GEN.taskCatalog) do
    if task.available and  d35.isGroupAlive(task.target) then
      table.insert(ret,task)
    end
  end
  return ret
end -- function
--===================================================================================================================================================
function GEN.deployEscortHelo(params)
  local clientName = params[1]
  local template = params[2]
  local name = params[3]
  local Client = CLIENT:FindByName( clientName )
  local Spawn_Heli =  SPAWN:New(template)
  local Escort = Spawn_Heli:SpawnAtAirbase( AIRBASE:FindByName( "FARP London - 01" ), SPAWN.Takeoff.Hot )
  GEN.EscortCount =   GEN.EscortCount + 1
  local EscortGroup = ESCORT:New( Client, Escort, string.format("%s (%s)",name,GEN.EscortCount) )
      :Menus()
      
      
  GEN.EscortSetGroup[GEN.EscortCount] = SET_GROUP:New():FilterPrefixes(Escort:GetName()):FilterStart()
  GEN.EscortDetection[GEN.EscortCount]  = DETECTION_AREAS:New( GEN.EscortSetGroup[GEN.EscortCount], 8000, 500 )
  
  GEN.EscortDetection[GEN.EscortCount]:BoundDetectedZones()
  GEN.EscortDetection[GEN.EscortCount]:SetRefreshTimeInterval( 15 )
      
  EscortGroup:SetDetection(GEN.EscortDetection[GEN.EscortCount] )
end -- function
--===================================================================================================================================================
function GEN.deployEscortFIX(params)
  local clientName = params[1]
  local template = params[2]
  local name = params[3]
  local Client = CLIENT:FindByName( clientName )
  local Spawn_Heli =  SPAWN:New(template)
  local Escort = Spawn_Heli:SpawnAtAirbase( AIRBASE:FindByName( "Gaziantep" ), SPAWN.Takeoff.Hot )
  GEN.EscortCount =   GEN.EscortCount + 1
  local EscortGroup = ESCORT:New( Client, Escort, string.format("%s (%s)",name,GEN.EscortCount) )
      :Menus()
      
      
  GEN.EscortSetGroup[GEN.EscortCount] = SET_GROUP:New():FilterPrefixes(Escort:GetName()):FilterStart()
  GEN.EscortDetection[GEN.EscortCount]  = DETECTION_AREAS:New( GEN.EscortSetGroup[GEN.EscortCount], 15000, 100 )
  
  GEN.EscortDetection[GEN.EscortCount]:BoundDetectedZones()
  GEN.EscortDetection[GEN.EscortCount]:SetRefreshTimeInterval( 15 )
      
  EscortGroup:SetDetection(GEN.EscortDetection[GEN.EscortCount] )
end -- function
--#################################################################################################################################################
-- #############   Main body   														                                                  												############### 
--#################################################################################################################################################
--
do

	-- load event handler
	world.addEventHandler(GEN.EventHandler)

	-- Show AFAC Status
	trigger.action.outText( 'Heli Sandbox - v'..GEN.gVersion, 1 )
end
